#
# spec file for package gforth (Version 0.6.2)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cpp41 cracklib ctags cvs cyrus-sasl db diffutils e2fsprogs emacs emacs-info emacs-nox file filesystem fillup findutils flex gawk gcc gcc41 gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc41 libltdl libmudflap41 libnscd libstdc++41 libtool libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           gforth
BuildRequires:  emacs-nox
URL:            http://www.gnu.org/software/gforth/
License:        GNU General Public License (GPL)
Group:          Development/Languages/Other
Autoreqprov:    on
PreReq:         %{install_info_prereq}
Version:        0.6.2
Release:        102
Summary:        GNU Forth
Source:         gforth-%{version}.tar.bz2
Patch:          gforth-%{version}.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Gforth is a fast and portable implementation of the ANS Forth language.



Authors:
--------
    Anton Ertl <anton@mips.complang.tuwien.ac.at>
    Bernd Paysan <paysan@informatik.tu-muenchen.de>
    Jens Wilke <wilke@jwdt.com>

%debug_package
%prep
%setup -q
%patch

%build
# Fixup timestamps. Can't rebuild them without working gforth
touch engine/prim.i engine/prim_lab.i
%{?suse_update_config}
autoreconf -fi
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" \
./configure --prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} \
            --build=%{_target_cpu}-suse-linux
make
make check
emacs --batch --no-site-file -f batch-byte-compile gforth.el
echo > gforth-autoloads.el
emacs --batch -l autoload --eval "(setq generated-autoload-file \"$PWD/gforth-autoloads.el\")" -f batch-update-autoloads .
{
  echo $';;; suse-start-gforth.el
;;
;;; Code:\n
(add-to-list \'auto-mode-alist \'("\\\\.fs\\\\\'" . forth-mode))\n'
  sed -n '/^;;; Generated/,/^;;;\*\*\*/p' gforth-autoloads.el
  echo $'\n;;; suse-start-gforth.el ends here'
} > suse-start-gforth.el
make install.TAGS gforth.fi

%install
make install prefix=$RPM_BUILD_ROOT/usr mandir=$RPM_BUILD_ROOT%{_mandir} \
	     infodir=$RPM_BUILD_ROOT%{_infodir}
install -d $RPM_BUILD_ROOT/usr/share/emacs/site-lisp
install -m 644 gforth.el gforth.elc suse-start-gforth.el $RPM_BUILD_ROOT/usr/share/emacs/site-lisp

%clean
rm -rf $RPM_BUILD_ROOT

%post
%install_info --info-dir=%{_infodir} %{_infodir}/gforth.info.gz

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gforth.info.gz

%files
%defattr(-,root,root)
%doc README BUGS NEWS
/usr/bin/gforth*
/usr/bin/vmgen
/usr/bin/vmgen-%{version}
%dir /usr/lib/gforth
/usr/lib/gforth/%{version}
/usr/share/emacs/site-lisp/*.el*
%dir /usr/share/gforth
/usr/share/gforth/%{version}
%dir /usr/share/gforth/site-forth
%config /usr/share/gforth/site-forth/siteinit.fs
%doc %{_infodir}/gforth.info*
%doc %{_infodir}/vmgen.info*
%doc %{_mandir}/man1/gforth.1.gz

%changelog -n gforth
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Thu Jan 19 2006 - schwab@suse.de
- Don't strip binaries.
* Tue Dec 20 2005 - dmueller@suse.de
- fix file list
* Wed Jan 21 2004 - schwab@suse.de
- Workaround gcc 3.3 bug.
* Fri Jan 09 2004 - schwab@suse.de
- Update to gforth 0.6.2.
* Tue Oct 28 2003 - schwab@suse.de
- Fix quoting in configure script.
* Wed Jul 02 2003 - schwab@suse.de
- Fix references to build root.
* Tue May 13 2003 - schwab@suse.de
- Fix filelist.
* Thu Apr 24 2003 - ro@suse.de
- fix install_info --delete call and move from preun to postun
* Wed Apr 23 2003 - schwab@suse.de
- Enable use of long long on ppc.
- Fix and compile gforth.el.
- Add suse-start-gforth.el.
- Include all gforth variants.
* Tue Apr 22 2003 - schwab@suse.de
- Use BuildRoot.
* Mon Apr 07 2003 - schwab@suse.de
- Only delete info entries when removing last version.
* Thu Mar 27 2003 - schwab@suse.de
- Update to gforth 0.6.1.
* Thu Feb 06 2003 - schwab@suse.de
- Use %%install_info.
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Thu Apr 18 2002 - schwab@suse.de
- Fix alpha port for gcc3.
* Thu Apr 18 2002 - schwab@suse.de
- Fix i386 port for gcc3.
* Mon Feb 25 2002 - schwab@suse.de
- Fix permissions.
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Sun Apr 15 2001 - schwab@suse.de
- Fix pointer <-> int clash.
* Fri Oct 06 2000 - schwab@suse.de
- Update to version 0.5.0.
* Thu Aug 17 2000 - schwab@suse.de
- Fix ia64 configuration.
* Thu Aug 17 2000 - schwab@suse.de
- Basic support for ia64.
* Tue Jan 18 2000 - schwab@suse.de
- /usr/{info,man} -> /usr/share/{info,man}
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug 30 1999 - schwab@suse.de
- specfile cleanup
- fix prims2x.fs:read-whole-file for make check
* Fri May 21 1999 - ro@suse.de
- update to 0.4.0
* Sat Jun 07 1997 - florian@suse.de
- first version of GNU forth 0.3 for S.u.S.E.
